/*-
 * Copyright (C)2000, 2001, 2002 @BABOLO http://www.links.ru/~babolo/
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 *
 * THIS SOFTWARE IS PROVIDED BY THE AUTHORS ``AS IS'' AND ANY EXPRESS OR
 * IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
 *  OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
 * IN NO EVENT SHALL THE REGENTS OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT,
 * INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
 * (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
 * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
 * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 * SUCH DAMAGE.
 */

#ifndef lint
static const char copyright[] = "\
@(#)Copyright (C)2000, 2001, 2002 @BABOLO http://www.links.ru/~babolo/\n\
@(#)All rights reserved.\n";
static const char rcsid[] = "$Id: pass1.c,v 1.1 2003/01/27 03:55:11 babolo Exp $";
#endif /* not lint */

#include <sys/types.h>
#include <sysexits.h>
#include <string.h>
#include <stdio.h>
#include "getCGIparm.h"

#define C_er 0x80000000 /*     -                                         */
#define C_r1 0x40000000 /*   %XX  ,            */
#define C_r2 0x20000000 /*                                                                   */
#define C_d0 0x10000000 /*    %XX                                */
#define C_dd  0x8000000 /*                                */
#define C_dh  0x4000000 /*    -       */
#define C_dH  0x2000000 /*    -      */
#define C_d2   0x800000 /*                                  */
#define C_mv   0x400000 /*     -                            */
#define C_mw   0x200000 /*      -             XXXX */
#define C_bb   0x100000 /*                                                        */
#define C_zr     0x8000 /*    \0 -                                        */
#define C_cm     0x4000 /*     ,    -         *
                         *                          */
#define C_ad     0x2000 /*                                                 */
#define C_np     0x1000 /*                                                       */
#define C_rs      0x400 /*    -                              XXXX */
#define C_in      0x200 /*     ,          */
#define C_rt      0x100 /*                                 */
#define C_state    0xFF /*                                                        */
#define C_r3  (C_r1|C_r2)
#define C_zin (C_zr|C_cm|C_in|C_np)
#define C_zrt (C_zr|C_rt|C_ad)

#ifdef DEBUG
u_char *pn[] = 
{ "er", "r1", "r2", "d0", "dd", "dh", "dH", "- "
, "d2", "mv", "mw", "bb", "- ", "- ", "- ", "- "
, "zr", "cm", "- ", "- ", "- ", "rs", "in", "rt"
};
u_char *statenames[] = {"d0", "d1", "d2", "v0", "v1", "v2", "vx", "dx"};
u_char *clasnames[] = {"no", "ok", "pc", "am", "eq", "pl", "hd", "hx", "hX", "nl", "xx"};
#endif
enum classes class[256] =
{nl,no,no,no ,no,no,no,no ,no,no,no,no ,no,no,no,no
,no,no,no,no ,no,no,no,no ,no,no,no,no ,no,no,no,no
,ok,ok,ok,ok ,ok,pc,am,ok ,ok,ok,ok,pl ,ok,ok,ok,ok
,hd,hd,hd,hd ,hd,hd,hd,hd ,hd,hd,ok,ok ,ok,eq,ok,ok

,ok,hX,hX,hX ,hX,hX,hX,ok ,ok,ok,ok,ok ,ok,ok,ok,ok
,ok,ok,ok,ok ,ok,ok,ok,ok ,ok,ok,ok,ok ,ok,ok,ok,ok
,ok,hx,hx,hx ,hx,hx,hx,ok ,ok,ok,ok,ok ,ok,ok,ok,ok
,ok,ok,ok,ok ,ok,ok,ok,ok ,ok,ok,ok,ok ,ok,ok,ok,ok

,ok,ok,ok,ok ,ok,ok,ok,ok ,ok,ok,ok,ok ,ok,ok,ok,ok
,ok,ok,ok,ok ,ok,ok,ok,ok ,ok,ok,ok,ok ,ok,ok,ok,ok
,ok,ok,ok,ok ,ok,ok,ok,ok ,ok,ok,ok,ok ,ok,ok,ok,ok
,ok,ok,ok,ok ,ok,ok,ok,ok ,ok,ok,ok,ok ,ok,ok,ok,ok

,ok,ok,ok,ok ,ok,ok,ok,ok ,ok,ok,ok,ok ,ok,ok,ok,ok
,ok,ok,ok,ok ,ok,ok,ok,ok ,ok,ok,ok,ok ,ok,ok,ok,ok
,ok,ok,ok,ok ,ok,ok,ok,ok ,ok,ok,ok,ok ,ok,ok,ok,ok
,ok,ok,ok,ok ,ok,ok,ok,ok ,ok,ok,ok,ok ,ok,ok,ok,ok
};

u_int32_t automa[xx][dx] =
/* &nnn=ee&        %XX=ee         %XX=ee       eee        e%XXee          e%XXee  &nn=ee&    */
/*   ^              ^               ^           ^           ^                ^       ^       */
/*      d0 ;           d1 ;           d2 ;      v0 ;           v1 ;           v2 ;     vx  */
{{C_er |dx , C_er |    dx , C_er |    dx , C_er|dx ,  C_er|    dx , C_er |    dx ,C_er|dx}/*C*/
,{C_mv |d0 ,C_r1|C_mv |d0 ,C_r3| C_mv|d0 ,C_mv |v0 ,C_r1|C_mv |v0 ,C_r3|C_mv |v0 ,     vx}/***/
,{C_d0 |d1 ,C_r1|      d1 ,C_r3|      d1 ,C_d0 |v1 ,C_r1|      v1 ,C_r3|      v1 ,     vx}/*%*/
,{C_in |d0 ,      C_in|d0 , C_in |    d0 ,C_zrt|dx ,C_r1|C_zrt|dx ,C_r3|C_zrt|dx ,     d0}/*&*/
,{C_zin|vx ,C_r1|C_zin|vx ,C_r3|C_zin|vx ,C_mv |v0 ,           dx ,           dx ,     vx}/*=*/
,{C_bb |d0 ,C_r1|C_bb |d0 ,C_r3| C_bb|d0 ,C_bb |v0 ,C_r1|C_bb |v0 ,C_r3|C_bb |v0 ,     vx}/*+*/
,{C_mv |d0 , C_dd |    d2 ,C_dd |C_d2|d0 ,C_mv |v0 , C_dd |    v2 ,C_dd |C_d2|v0 ,     vx}/*9*/
,{C_mv |d0 , C_dh |    d2 ,C_dh |C_d2|d0 ,C_mv |v0 , C_dh |    v2 ,C_dh |C_d2|v0 ,     vx}/*h*/
,{C_mv |d0 , C_dH |    d2 ,C_dH |C_d2|d0 ,C_mv |v0 , C_dH |    v2 ,C_dH |C_d2|v0 ,     vx}/*H*/
,{ C_np|dx ,      C_np|dx , C_np |    dx ,C_zrt|dx ,C_r1|C_zrt|dx ,C_r3|C_zrt|dx ,     dx}/*0*/
};

int
pass1( u_int32_t flags
     , u_char **query
     , u_char *tofind
     , u_char *unescaped
     )
{   u_char *p, *q, *pointer, value;
    u_int32_t control = 0;
    enum states state;
    int ex = EX_OK;
#ifdef DEBUG
    int i, j, k;
#endif

    if  (flags & VERB)
        fprintf( stderr
               , "P1 flags=%06X, query=%s~, tofind=%s~, unescaped=%08X~\n"
               , flags
               , query ? (*query ? *query : empty) : empty
               , tofind ? tofind : empty
               , (long)unescaped
               );
    /*    *query   q
     *   unescaped   p
     * pointer -   ,
     *        %XX 
     */
    q = *query;
    p = unescaped;
    state = tofind ? d0 : v0;
    pointer = q;
    value = 0;
        
    while (state < dx)
    {   control = automa[class[*q]][state];
#ifdef DEBUG
        fprintf( stderr, "%08X ", control);
        for (i = 0, j = control, k = 0; i < 24; i++, j <<= 1)
# ifdef ALLIGN_TABLE
            if  ((pn[i][0] != '-') || (j & 0x80000000))
                fprintf( stderr, "%s ", (j & 0x80000000) ? pn[i] : "  ");
        fprintf( stderr, "%02X %s %s %08X ~%s~\n"
# else
            if  (j & 0x80000000)
            {   fprintf( stderr, "%s ", pn[i]);
                k++;
            };
        for (; k < 3; k++) fprintf( stderr, "   ");
        fprintf( stderr, "\t%02X %s %s %08X ~%s~\n"
# endif
               , value, clasnames[class[*q]], statenames[state], (unsigned)q, q
               );
#endif
        if  (control & C_er) ex = EX_DATAERR;
        if  (control & C_r1) *p++ = *pointer++;
        if  (control & C_r2) *p++ = *pointer++;
        if  (control & C_d0) pointer = q;
        if  (control & C_dd) value = (value << 4) | ((*q - '0') & 0x0F);
        if  (control & C_dh) value = (value << 4) | ((*q - 'a' + 10) & 0x0F);
        if  (control & C_dH) value = (value << 4) | ((*q - 'A' + 10) & 0x0F);
        if  (  control & C_d2
            && (~flags & NOCR || ((value & 0xFF) != '\r'))
            && (~flags & NOLF || ((value & 0xFF) != '\n'))
            ) *p++ = value & 0xFF;
        if  (control & C_mv) *p++ = *q;
        if  (control & C_bb) *p++ = ' ';
        if  (control & C_zr) *p++ = '\0';
        if  (control & C_cm && !strcmp(unescaped, tofind)) control = C_in | C_np | v0;
        if  (flags & VERM || control & C_rs)
        {   if  (flags & NOLF) printf("%s", unescaped);
            else printf("%s\n", unescaped);
        }
        if  (control & C_in) p = unescaped;
        if  (control & C_np) *p = '\0';
        if  (~control & C_ad) q++;
        state = control & C_state;
    }
    p = unescaped;
    *query = q;
    if  (flags & VERB) fprintf(stderr, "ex=%d %08X ~%s~%s~\n", ex, control, p, q);
    return((control & C_rt) ? ex : EX_DATAERR);
}
